#-----------------------------------------------------------------------
# File    : makefile    (directory: nass)
# Contents: build neuron assembly program
# Author  : Christian Borgelt
# History : 2008.08.27 file created
#           2008.10.05 adapted to utility and math modules
#-----------------------------------------------------------------------
THISDIR  = ..\..\genpst\src
UTILDIR  = ..\..\util\src

CC       = cl.exe
DEFS     = /D WIN32 /D NDEBUG /D _CONSOLE /D _CRT_SECURE_NO_WARNINGS
CFLAGS   = /nologo /W3 /O2 /GS- $(DEFS) /c
INCS     = /I $(UTILDIR)

LD       = link.exe
LDFLAGS  = /nologo /subsystem:console /incremental:no
LIBS     = 

HDRS     = $(UTILDIR)\arrays.h   $(UTILDIR)\random.h
OBJS     = $(UTILDIR)\arrays.obj $(UTILDIR)\random.obj
PRGS     = genpst.exe

#-----------------------------------------------------------------------
# Build Programs
#-----------------------------------------------------------------------
all:          $(PRGS)

genpst.exe:   $(OBJS) genpst.obj genpst.mak
	$(LD) $(LDFLAGS) $(LIBS) $(OBJS) genpst.obj /out:$@

#-----------------------------------------------------------------------
# Main Programs
#-----------------------------------------------------------------------
genpst.obj:   $(HDRS) genpst.c genpst.mak
	$(CC) $(CFLAGS) $(INCS) genpst.c /Fo$@

#-----------------------------------------------------------------------
# External Modules
#-----------------------------------------------------------------------
$(UTILDIR)\arrays.obj:
	cd $(UTILDIR)
	$(MAKE) /f util.mak arrays.obj
	cd $(THISDIR)
$(UTILDIR)\random.obj:
	cd $(UTILDIR)
	$(MAKE) /f util.mak random.obj
	cd $(THISDIR)

#-----------------------------------------------------------------------
# Install
#-----------------------------------------------------------------------
install:
	-@copy *.exe ..\..\..\bin

#-----------------------------------------------------------------------
# Clean up
#-----------------------------------------------------------------------
localclean:
	-@erase /Q *~ *.obj *.idb *.pch $(PRGS)

clean:
	$(MAKE) /f genpst.mak localclean
	cd $(UTILDIR)
	$(MAKE) /f util.mak clean
	cd $(THISDIR)
